%I.E
clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Linear',100, 1000, 0.1); %Create dataset

tval=linspace(1e-3,1e0,500); %Define range of parameters
for i=[1:numel(tval)]
  [alpha, err] = learn('lin', [], 'rls', tval(i), X, Y, 'class'); %Learn on each parameter
  
  training_error(i) = cell2mat(err); %Get the training error
  Y_learnt = kernel('lin', [], Xt, X) * cell2mat(alpha);
  test_error(i) = learn_error(Y_learnt, Yt, 'class'); %Get the test error
end
  figure;semilogx(tval,training_error);% Plots the results
  figure;semilogx(tval,test_error); %This one can show some overfitting when t goes to zero

[t_kcv_idx, avg_err_kcv] = kcv('lin', [], 'rls', tval, X, Y, 5, 'class', 'seq');
figure;semilogx(tval,avg_err_kcv);




%I.F
clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Linear',300, 1000, 0.1); %Create dataset

t=1; % We fix the regularization parameter
for n=[1:size(X,1)],
  [alpha, err] = learn('lin', [], 'rls', t, X(1:n,:), Y(1:n,:), 'class');
training_error(n) = cell2mat(err);
Y_learnt = kernel('lin', [], Xt, X(1:n,:)) * cell2mat(alpha);
test_error(n) = learn_error(Y_learnt, Yt, 'class');
end
  figure;plot([1:size(X,1)],training_error);% can increase with size
  figure;plot([1:size(X,1)],test_error); %decrease with size

    
 %II.A
 %FIrst we can fix t an look for the best sigma
 
clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Linear',100, 1000, 0.1); %Create dataset
tval=1e-2;
sigma=linspace(1e-3,1e0,500); %Define range of parameters
for i=[1:numel(sigma)]
  [alpha, err] = learn('gauss', sigma(i), 'rls', tval, X, Y, 'class'); %Learn on each parameter
  
  training_error(i) = cell2mat(err); %Get the training error
  Y_learnt = kernel('lin', sigma(i), Xt, X) * cell2mat(alpha);
  test_error(i) = learn_error(Y_learnt, Yt, 'class'); %Get the test error
end
  figure;semilogx(sigma,training_error);% Plots the results
  figure;semilogx(sigma,test_error); %This one can show some overfitting when t goes to zero

  
   %second we can try to optimize both sigma and t
 
clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Linear',100, 1000, 0.1); %Create dataset
tval=linspace(1e-3,1e-1,50);
sigma=linspace(1e-3,1e0,50); %Define range of parameters
for i=[1:numel(sigma)]
  [alpha, err] = learn('gauss', sigma(i), 'rls', tval, X, Y, 'class'); %Learn on each parameter
  
  training_error(i,:) = cell2mat(err); %Get the training error
  for j=[1:numel(tval)]
  Y_learnt = kernel('lin', sigma(i), Xt, X) * alpha{j};
  test_error(i,j) = learn_error(Y_learnt, Yt, 'class'); %Get the test error
  end
end
  figure;plot3(sigma,tval,training_error);% Plots the results
  figure;plot3(sigma,tval,test_error); %This one can show some overfitting when t goes to zero

  
      
 %II.B
 %FIrst we can fix t an look for the best degree for the polynomials
 
clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Spiral',100, 1000, 0.1); %Create dataset
tval=1e-2;
sigma=[1:50]; %Define range of parameters
for i=[1:numel(sigma)]
  [alpha, err] = learn('pol', sigma(i), 'rls', tval, X, Y, 'class'); %Learn on each parameter
  
  training_error(i) = cell2mat(err); %Get the training error
  Y_learnt = kernel('pol', sigma(i), Xt, X) * cell2mat(alpha);
  test_error(i) = learn_error(Y_learnt, Yt, 'class'); %Get the test error
end
  figure;semilogx(sigma,training_error);% Plots the results
  figure;semilogx(sigma,test_error); %This one can show some overfitting when t goes to zero
  
  
  %Second we can look at what happens when the size increase
  % Moons and gauss
  clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Moons',300, 1000, 0.1); %Create dataset

t=0.01; % We fix the regularization parameter
sigma=0.1;
for n=[1:size(X,1)],
  [alpha, err] = learn('gauss', sigma, 'rls', t, X(1:n,:), Y(1:n,:), 'class');
training_error(n) = cell2mat(err);
Y_learnt = kernel('gauss', sigma, Xt, X(1:n,:)) * cell2mat(alpha);
test_error(n) = learn_error(Y_learnt, Yt, 'class');
end
  figure;plot([1:size(X,1)],training_error); %increases
  figure;plot([1:size(X,1)],test_error); %decreases
  
    % Moons and pol
  clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Moons',300, 1000, 0.1); %Create dataset

t=0.01; % We fix the regularization parameter
sigma=15;
for n=[1:size(X,1)],
  [alpha, err] = learn('pol', sigma, 'rls', t, X(1:n,:), Y(1:n,:), 'class');
training_error(n) = cell2mat(err);
Y_learnt = kernel('pol', sigma, Xt, X(1:n,:)) * cell2mat(alpha);
test_error(n) = learn_error(Y_learnt, Yt, 'class');
end
  figure;plot([1:size(X,1)],training_error); %increases
  figure;plot([1:size(X,1)],test_error); %decreases
  
  % Spiral and gauss
  clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Spiral',300, 1000, 0.1); %Create dataset

t=0.01; % We fix the regularization parameter
sigma=0.1;
for n=[1:size(X,1)],
  [alpha, err] = learn('gauss', sigma, 'rls', t, X(1:n,:), Y(1:n,:), 'class');
training_error(n) = cell2mat(err);
Y_learnt = kernel('gauss', sigma, Xt, X(1:n,:)) * cell2mat(alpha);
test_error(n) = learn_error(Y_learnt, Yt, 'class');
end
  figure;plot([1:size(X,1)],training_error); %increases
  figure;plot([1:size(X,1)],test_error); %decreases
  
    % Spiral and pol: doesn't work
  clear all; close all;
[X, Y, Xt, Yt] = loadDataset('Spiral',300, 1000, 0.1); %Create dataset

t=0.01; % We fix the regularization parameter
sigma=15;
for n=[1:size(X,1)],
  [alpha, err] = learn('pol', sigma, 'rls', t, X(1:n,:), Y(1:n,:), 'class');
training_error(n) = cell2mat(err);
Y_learnt = kernel('pol', sigma, Xt, X(1:n,:)) * cell2mat(alpha);
test_error(n) = learn_error(Y_learnt, Yt, 'class');
end
  figure;plot([1:size(X,1)],training_error); % shit
  figure;plot([1:size(X,1)],test_error); % shit
  
  
  
  
  
  
  
  
  